window.Gleam.initSearch([{"doc":"glyph","title":"glyph","content":"# gliscord\n\n[![Package Version](https://img.shields.io/hexpm/v/gliscord)](https://hex.pm/packages/gliscord)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gliscord/)\n\n```sh\ngleam add gliscord\n```\n```gleam\nimport gliscord\n\npub fn main() {\n  // TODO: An example of the project in use\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gliscord&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"clients/bot","title":"clients/bot","content":"","url":"clients/bot.html"},{"doc":"models/api","title":"Application","content":"pub type Application {\n  Application(\n    id: Snowflake,\n    name: String,\n    icon: Option(String),\n    description: String,\n    rpc_origins: Option(List(String)),\n    bot_public: Bool,\n    bot_require_code_grant: Bool,\n    bot: Option(Bot),\n    terms_of_service_url: Option(String),\n    privacy_policy_url: Option(String),\n    owner: Option(Owner),\n    summary: Option(String),\n    verify_key: String,\n    team: Option(Team),\n    guild_id: Option(Snowflake),\n    primary_sku_id: Option(Snowflake),\n    slug: Option(String),\n    cover_image: Option(String),\n    flags: Option(Int),\n    approximate_guild_count: Option(Int),\n    redirect_uris: Option(List(String)),\n    interactions_endpoint_url: Option(String),\n    role_connections_verification_url: Option(String),\n    tags: Option(List(String)),\n    install_params: Option(InstallParams),\n    custom_install_url: Option(String),\n  )\n}\n Model for a Discord Application: https://discord.com/developers/docs/resources/application\n Note to self: summary is deprecated and will be removed in v11\nApplication(\n  id: Snowflake,\n  name: String,\n  icon: Option(String),\n  description: String,\n  rpc_origins: Option(List(String)),\n  bot_public: Bool,\n  bot_require_code_grant: Bool,\n  bot: Option(Bot),\n  terms_of_service_url: Option(String),\n  privacy_policy_url: Option(String),\n  owner: Option(Owner),\n  summary: Option(String),\n  verify_key: String,\n  team: Option(Team),\n  guild_id: Option(Snowflake),\n  primary_sku_id: Option(Snowflake),\n  slug: Option(String),\n  cover_image: Option(String),\n  flags: Option(Int),\n  approximate_guild_count: Option(Int),\n  redirect_uris: Option(List(String)),\n  interactions_endpoint_url: Option(String),\n  role_connections_verification_url: Option(String),\n  tags: Option(List(String)),\n  install_params: Option(InstallParams),\n  custom_install_url: Option(String),\n)\n\n\nSynonyms:\nmodels/api.Application\nmodels/api Application","url":"models/api.html#Application"},{"doc":"models/api","title":"Bot","content":"pub type Bot =\n  User\n\n\nSynonyms:\nmodels/api.Bot\nmodels/api Bot","url":"models/api.html#Bot"},{"doc":"models/api","title":"InstallParams","content":"pub type InstallParams {\n  InstallParams(scopes: List(String), permissions: String)\n}\n Model for Install Params: https://discord.com/developers/docs/resources/application#install-params-object\nInstallParams(scopes: List(String), permissions: String)\n\n\nSynonyms:\nmodels/api.InstallParams\nmodels/api InstallParams","url":"models/api.html#InstallParams"},{"doc":"models/api","title":"Member","content":"pub type Member {\n  Member(\n    membership_state: Int,\n    team_id: Snowflake,\n    user: User,\n    role: String,\n  )\n}\n Model for a Team Member object: https://discord.com/developers/docs/topics/teams#data-models-team-member-object\nMember(\n  membership_state: Int,\n  team_id: Snowflake,\n  user: User,\n  role: String,\n)\n\n\nSynonyms:\nmodels/api.Member\nmodels/api Member","url":"models/api.html#Member"},{"doc":"models/api","title":"MembershipState","content":"pub type MembershipState {\n  INVITED\n  ACCEPTED\n}\n Model for Membership State: https://discord.com/developers/docs/topics/teams#data-models-membership-state-enum\nINVITED\n\n\nACCEPTED\n\n\nSynonyms:\nmodels/api.MembershipState\nmodels/api MembershipState","url":"models/api.html#MembershipState"},{"doc":"models/api","title":"Owner","content":"pub type Owner =\n  User\n\n\nSynonyms:\nmodels/api.Owner\nmodels/api Owner","url":"models/api.html#Owner"},{"doc":"models/api","title":"Snowflake","content":"pub type Snowflake =\n  String\n The data structure Discord uses for UUIDs: https://discord.com/developers/docs/reference#snowflakes\n\nSynonyms:\nmodels/api.Snowflake\nmodels/api Snowflake","url":"models/api.html#Snowflake"},{"doc":"models/api","title":"Team","content":"pub type Team {\n  Team(\n    id: Snowflake,\n    icon: Option(String),\n    members: List(Member),\n    name: String,\n    owner_user_id: Snowflake,\n  )\n}\n Model for a Team object: https://discord.com/developers/docs/topics/teams#data-models-team-object\nTeam(\n  id: Snowflake,\n  icon: Option(String),\n  members: List(Member),\n  name: String,\n  owner_user_id: Snowflake,\n)\n\n\nSynonyms:\nmodels/api.Team\nmodels/api Team","url":"models/api.html#Team"},{"doc":"models/api","title":"User","content":"pub type User {\n  User(\n    id: Snowflake,\n    username: String,\n    discriminator: String,\n    global_name: Option(String),\n    avatar: Option(String),\n    bot: Option(Bool),\n    system: Option(Bool),\n    mfa_enabled: Option(Bool),\n    banner: Option(String),\n    accent_color: Option(Int),\n    locale: Option(String),\n    email: Option(String),\n    flags: Option(Int),\n    premium_type: Option(Int),\n    public_flags: Option(Int),\n    avatar_decoration: Option(String),\n  )\n}\n Model for a Discord User: https://discord.com/developers/docs/resources/user#user-object\n Some additional fields marked as optional here due to the use of partial user objects\n in other areas of the API.\nUser(\n  id: Snowflake,\n  username: String,\n  discriminator: String,\n  global_name: Option(String),\n  avatar: Option(String),\n  bot: Option(Bool),\n  system: Option(Bool),\n  mfa_enabled: Option(Bool),\n  banner: Option(String),\n  accent_color: Option(Int),\n  locale: Option(String),\n  email: Option(String),\n  flags: Option(Int),\n  premium_type: Option(Int),\n  public_flags: Option(Int),\n  avatar_decoration: Option(String),\n)\n\n\nSynonyms:\nmodels/api.User\nmodels/api User","url":"models/api.html#User"},{"doc":"models/api","title":"models/api","content":" This contains all types needed to communicate with either the Gateway or REST API.","url":"models/api.html"},{"doc":"models/decoders","title":"ApplicationDecoder","content":"pub type ApplicationDecoder(app) =\n  fn(Dynamic) -&gt; Result(app, DecodeErrors)\n\n\nSynonyms:\nmodels/decoders.ApplicationDecoder\nmodels/decoders ApplicationDecoder","url":"models/decoders.html#ApplicationDecoder"},{"doc":"models/decoders","title":"InstallParamsDecoder","content":"pub type InstallParamsDecoder(install_params) =\n  fn(Dynamic) -&gt; Result(install_params, DecodeErrors)\n\n\nSynonyms:\nmodels/decoders.InstallParamsDecoder\nmodels/decoders InstallParamsDecoder","url":"models/decoders.html#InstallParamsDecoder"},{"doc":"models/decoders","title":"MemberDecoder","content":"pub type MemberDecoder(member) =\n  fn(Dynamic) -&gt; Result(member, DecodeErrors)\n\n\nSynonyms:\nmodels/decoders.MemberDecoder\nmodels/decoders MemberDecoder","url":"models/decoders.html#MemberDecoder"},{"doc":"models/decoders","title":"TeamDecoder","content":"pub type TeamDecoder(team) =\n  fn(Dynamic) -&gt; Result(team, DecodeErrors)\n\n\nSynonyms:\nmodels/decoders.TeamDecoder\nmodels/decoders TeamDecoder","url":"models/decoders.html#TeamDecoder"},{"doc":"models/decoders","title":"UserDecoder","content":"pub type UserDecoder(user) =\n  fn(Dynamic) -&gt; Result(user, DecodeErrors)\n\n\nSynonyms:\nmodels/decoders.UserDecoder\nmodels/decoders UserDecoder","url":"models/decoders.html#UserDecoder"},{"doc":"models/decoders","title":"application","content":"pub fn application(\n  constructor: fn(\n    a,\n    b,\n    c,\n    d,\n    e,\n    f,\n    g,\n    h,\n    i,\n    j,\n    k,\n    l,\n    m,\n    n,\n    o,\n    p,\n    q,\n    r,\n    s,\n    t,\n    u,\n    v,\n    w,\n    x,\n    y,\n    z,\n  ) -&gt; Application,\n  id: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  name: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  icon: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  description: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  rpc_origins: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n  bot_public: fn(Dynamic) -&gt; Result(f, List(DecodeError)),\n  bot_require_code_grant: fn(Dynamic) -&gt;\n    Result(g, List(DecodeError)),\n  bot: fn(Dynamic) -&gt; Result(h, List(DecodeError)),\n  terms_of_service_url: fn(Dynamic) -&gt;\n    Result(i, List(DecodeError)),\n  privacy_policy_url: fn(Dynamic) -&gt; Result(j, List(DecodeError)),\n  owner: fn(Dynamic) -&gt; Result(k, List(DecodeError)),\n  summary: fn(Dynamic) -&gt; Result(l, List(DecodeError)),\n  verify_key: fn(Dynamic) -&gt; Result(m, List(DecodeError)),\n  team: fn(Dynamic) -&gt; Result(n, List(DecodeError)),\n  guild_id: fn(Dynamic) -&gt; Result(o, List(DecodeError)),\n  primary_sku_id: fn(Dynamic) -&gt; Result(p, List(DecodeError)),\n  slug: fn(Dynamic) -&gt; Result(q, List(DecodeError)),\n  cover_image: fn(Dynamic) -&gt; Result(r, List(DecodeError)),\n  flags: fn(Dynamic) -&gt; Result(s, List(DecodeError)),\n  approximate_guild_count: fn(Dynamic) -&gt;\n    Result(t, List(DecodeError)),\n  redirect_uris: fn(Dynamic) -&gt; Result(u, List(DecodeError)),\n  interactions_endpoint_url: fn(Dynamic) -&gt;\n    Result(v, List(DecodeError)),\n  role_connections_verification_url: fn(Dynamic) -&gt;\n    Result(w, List(DecodeError)),\n  tags: fn(Dynamic) -&gt; Result(x, List(DecodeError)),\n  install_params: fn(Dynamic) -&gt; Result(y, List(DecodeError)),\n  custom_install_url: fn(Dynamic) -&gt; Result(z, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(Application, List(DecodeError))\n\nSynonyms:\nmodels/decoders.application\nmodels/decoders application","url":"models/decoders.html#application"},{"doc":"models/decoders","title":"install_params","content":"pub fn install_params(\n  constructor: fn(a, b) -&gt; InstallParams,\n  scopes: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  permissions: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(InstallParams, List(DecodeError))\n\nSynonyms:\nmodels/decoders.install_params\nmodels/decoders install_params","url":"models/decoders.html#install_params"},{"doc":"models/decoders","title":"member","content":"pub fn member(\n  constructor: fn(a, b, c, d) -&gt; Member,\n  membership_state: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  team_id: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  user: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  role: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(Member, List(DecodeError))\n\nSynonyms:\nmodels/decoders.member\nmodels/decoders member","url":"models/decoders.html#member"},{"doc":"models/decoders","title":"team","content":"pub fn team(\n  constructor: fn(a, b, c, d, e) -&gt; Team,\n  id: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  icon: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  members: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  name: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  owner_user_id: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(Team, List(DecodeError))\n\nSynonyms:\nmodels/decoders.team\nmodels/decoders team","url":"models/decoders.html#team"},{"doc":"models/decoders","title":"user","content":"pub fn user(\n  constructor: fn(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) -&gt;\n    User,\n  id: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  username: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  discriminator: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  global_name: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  avatar: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n  bot: fn(Dynamic) -&gt; Result(f, List(DecodeError)),\n  system: fn(Dynamic) -&gt; Result(g, List(DecodeError)),\n  mfa_enabled: fn(Dynamic) -&gt; Result(h, List(DecodeError)),\n  banner: fn(Dynamic) -&gt; Result(i, List(DecodeError)),\n  accent_color: fn(Dynamic) -&gt; Result(j, List(DecodeError)),\n  locale: fn(Dynamic) -&gt; Result(k, List(DecodeError)),\n  email: fn(Dynamic) -&gt; Result(l, List(DecodeError)),\n  flags: fn(Dynamic) -&gt; Result(m, List(DecodeError)),\n  premium_type: fn(Dynamic) -&gt; Result(n, List(DecodeError)),\n  public_flags: fn(Dynamic) -&gt; Result(o, List(DecodeError)),\n  avatar_decoration: fn(Dynamic) -&gt; Result(p, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(User, List(DecodeError))\n\nSynonyms:\nmodels/decoders.user\nmodels/decoders user","url":"models/decoders.html#user"},{"doc":"models/decoders","title":"models/decoders","content":" This contains all decoders needed to parse responses into models.\n Adapted from Gleam&#39;s stdlib dynamic decoders.\n \n Abandon all hope, ye who enter.","url":"models/decoders.html"},{"doc":"network/rest","title":"TokenType","content":"pub type TokenType {\n  Bearer\n  Bot\n}\n Acceptable values for an Authorization header\nBearer\n\n\nBot\n\n\nSynonyms:\nnetwork/rest.TokenType\nnetwork/rest TokenType","url":"network/rest.html#TokenType"},{"doc":"network/rest","title":"decode_application","content":"pub fn decode_application(\n  json_string: String,\n) -&gt; Result(Application, DecodeError)\n\nSynonyms:\nnetwork/rest.decode_application\nnetwork/rest decode_application","url":"network/rest.html#decode_application"},{"doc":"network/rest","title":"request","content":"pub fn request(\n  ua_url: String,\n  version: String,\n  token_type: TokenType,\n  token: String,\n) -&gt; Result(Response(String), Error)\n\nSynonyms:\nnetwork/rest.request\nnetwork/rest request","url":"network/rest.html#request"},{"doc":"network/rest","title":"network/rest","content":" This handles the logic for communicating with the Discord REST API. For more information: https://discord.com/developers/docs/reference#http-api","url":"network/rest.html"},{"doc":"glyph","title":"main","content":"pub fn main() -&gt; Result(Response(String), Nil)\n\nSynonyms:\nglyph.main\nglyph main","url":"glyph.html#main"},{"doc":"glyph","title":"glyph","content":"","url":"glyph.html"},{"doc":"network/gateway","title":"network/gateway","content":"","url":"network/gateway.html"}]);